int verbosity =2;
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <iostream>
#include <fstream>
#include "rgraph.hpp"
using namespace std;  

#include "throwassert.hpp"
#include "Expression.hpp"
#include "MatriceCreuse_tpl.hpp"
#include "QuadratureFormular.hpp"
using namespace Fem2D;

class Domaine{ public:
  virtual void f()=0;
};

  class tab {
    int n,nx;
    Domaine ** d;
    tab(int nnx) : nx(nnx),d(new Domaine*[nnx]),n(0) {}
    };


//#pragma optimization_level 0
#include <ctime>
inline double CPUtime(){
#ifdef SYSTIMES
  struct tms buf;
  if (times(&buf)!=-1)
    return ((double)buf.tms_utime+(double)buf.tms_stime)/(long) sysconf(_SC_CLK_TCK);
  else
#endif
    return ((double) clock())/CLOCKS_PER_SEC;
}

/*
void  Element_Op(MatriceElementairePleine<R> & mat,const FElement & Ku,const FElement & Kv,R * p,int,
              int, void* mydata))
{
  bool same = &Ku == & Kv;
  const Triangle & T  = Ku.T;
  assert(&T == &Kv.T);  
  const FormuleIntegration & FI = FormuleIntegration_T_5;
  int npi;
  R *a=mat.a;
  R *pa=a;
  int i,j;
  int n= mat.n,m=mat.m,nx=n*m;
  int N= Ku.N;
  int M= Kv.N;
  
  
  RNMK_ fu(p,n,N,3); //  the value for basic fonction
  RNMK_ fv(p+ (same ?0:n*N*3) ,m,M,3); //  the value for basic fonction
  
   
  const Opera &Op(*mat.bilinearform);

  for (i=0;i< nx;i++) 
    *pa++ = 0.;    
  for (npi=0;npi<FI.n;npi++) // loop on the integration point
    {
      PointIntegration pi(FI[npi]);
      R coef = T.area*pi.a;
      R2 Pt(pi);
      pa =a;
      Ku.BF(Pt,fu);
      if (!same) Kv.BF(Pt,fv);      
      for ( i=0;  i<n;   i++ )  
	  { 
       RNM_ wi(fu(i,'.','.'));	    
       for ( j=0;  j<m;   i++ ) 
        { 
         RNM_ wj(fv(j,'.','.'));
         for (BilinearOperator::const_iterator l=Op.v.begin();l!=Op.v.end();l++)
         {       
          pair<int,int> ii(l->first.first),jj(l->first.second);
		  R w_i =  wi(ii.first,ii.second);
		  R w_j =  wj(jj.first,jj.second);
		  *pa += coef * l->second * w_i * w_j;
		  }
	     }
	    }
     }
 }  
     
 

void  Element_Op(MatriceElementaireSymetrique<R> & mat,const FElement & Ku,R * p,int,
              int, void* mydata))
{
  const Triangle & T  = Ku.T;
  const FormuleIntegration & FI = FormuleIntegration_T_2;
  int npi;
  R *a=mat.a;
  R *pa=a;
  int i,j;
  int n= mat.n,m=mat.m,nx=n*(m+1)/2;
  int N= Ku.N;
  int M=N;
  bool show = Ku.Vh.Th(T)==0;
  char * xxx[] ={" u"," v,"," p"," q"," r"};
  char * xxxx[] ={" u'"," v',"," p'"," q'"," r'"};
  char * yyy[] ={" ","_x ","_y "};
  
  RNMK_ fu(p,n,N,3); //  the value for basic fonction
  
  assert(mat.bilinearform);
   
  const Opera &Op(*mat.bilinearform);

  for (i=0;i< nx;i++) 
    *pa++ = 0.;    
  for (npi=0;npi<FI.n;npi++) // loop on the integration point
    {
      PointIntegration pi(FI[npi]);
      R coef = T.area*pi.a;
      R2 Pt(pi);
      pa =a;
      Ku.BF(Pt,fu);
      
     for ( i=0;  i<n;   i++ )  
	  { 
       RNM_ wi(fu(i,'.','.'));
	   for ( j=0;  j<=i;  j++,pa++ ) // 
	    {
	    
         RNM_ wj(fu(j,'.','.'));
         for (BilinearOperator::const_iterator l=Op.v.begin();l!=Op.v.end();l++)
         {       
          pair<int,int> ii(l->first.first),jj(l->first.second);
		  R w_i =  wi(ii.first,ii.second);
		  R w_j =  wj(jj.first,jj.second);
		  *pa += coef * l->second * w_i * w_j;
		  }
	    }
	  }

    }  
 if (show) 
  for (int i=0;i<n;i++)
  { cout << i << ":" ;
   for (int j=0;j<=i;j++)
    cout << mat(i,j) << " ";
   cout << endl;} 	   
    
     
 }

*/

static R KStokes,KUV, KVgradP, KPena;
void MatStokes(MatriceElementaireSymetrique<R> & mat,const FElement & K,R * p,int,
              int, void* mydata)
{ // 
 
    //   matrix  3x3
    //    e 0 gx
    //    0 e gy 
    //    gx gy d 
    const Triangle & T = K.T;  // the current triangle
     
    for (int i=0,i3=0;i<3;i++, i3+=3)
	{
	    R2 Gi = T.H(i);// some optimisation        
	    for (int j=0,j3=0;j<=i;j++, j3+=3) // the 3 sub matrix
		{
		    R2 Gj = T.H(j);// some optimisation 
		    R cStokes = T.area* KStokes;
		    R cVgradP = T.area* KVgradP;
		    R cPena   = T.area* KPena;
		    R cUV     = T.area *  KUV  ;
		    R gg  = (Gi,Gj);
		    R ggs = gg * cStokes;
		    R uv = cUV/12;
		    R pq = 0;//1./12.;
		    if ( i3==j3) {uv += uv;pq += pq;}
		    //          diagonal 	        
		    mat(i3  ,j3   ) =  ggs  + uv;
		    mat(i3+1,j3+1)  =  ggs  + uv;
		    mat(i3+2,j3+2)  = -(gg+pq)*cPena ;
		    if(j<i) 
			{
			    //             Upper part 3x3
			    mat(i3  ,j3+1)  = 0 ;
			    mat(i3  ,j3+2)  = -cVgradP*Gi.x/3;
			    mat(i3+1,j3+2)  = -cVgradP*Gi.y/3;
			}
		    //            Lower part 3x3            
		    mat(i3+1,j3  )  = 0;
		    mat(i3+2,j3  )  = -cVgradP*Gj.x/3;            
		    mat(i3+2,j3+1)  = -cVgradP*Gj.y/3;             
		}          
 
	} 
 if ( K.Vh.Th(T)==0) 
  for (int i=0;i<9;i++)
  { cout << i << ":" ;
   for (int j=0;j<=i;j++)
    cout << mat(i,j) << " ";
   cout << endl;} 	   
       
}
void ForDebug()
{
    cout << " ForDebug  " << endl;
}
 
int main(int argc,char **argv)
{

    initgraphique();
    int i;
    atexit(ForDebug);
    cout << " begin" << endl ;
    const char  * fn= (argc<2)?"c30x30.msh":argv[1]; 
    Mesh Th(fn);
    Th.renum();
    Th.Draw();
    RN Viso(20);
    FESpace vh(Th); // u,v,p
    FESpace Vh(vh,3); // u ou v ou p
    MatriceProfile<R> A(Vh);
    MatriceElementaireSymetrique<R> mate(Vh);
    KStokes = 1;
    KVgradP = 1;
    KUV     = 0;
    KPena   = 0.001;
/*
    Opera Laplace2 = U_x(0)*V_x(0)+U_y(0)*V_y(0) +U_x(1)*V_x(1)+U_y(1)*V_y(1);
                    
    Opera Stokes = ( U_(0)*V_(0)+U_(1)*V_(1))*KUV
                  + (Laplace2) *KStokes
                  + (  DiffG(2,1)*DiffD(0,0)+DiffG(2,2)*DiffD(1,0)
                     + DiffG(0,0)*DiffD(2,1)+DiffG(1,0)*DiffD(2,2) ) * KVgradP                 
                  - (DiffG(2,1)*DiffD(2,1)+DiffG(2,2)*DiffD(2,2))*KPena;
    cout << "Stokes " << Stokes << endl;
*/    
 //   mate.element = MatStokes;
  //  mate.bilinearform = &Stokes;
  //  mate.element = Element_Op;
    mate.element = MatStokes;
    R T0=CPUtime();
    for ( i=0;i< Th.nt; i++) 
      A += mate(i,-1,0,0);
     R T1=CPUtime();  
    cout << " CPU assemble "<< T1-T0 << "s" << endl;
    const R tgv = 1e30;
    RNM U(3,Th.nv);
    U = 0;
    // 
    {  RNM_ D3(A.D,3,Th.nv); // le vecteur diagonal 
    for (i=0;i< Th.nv; i++)
	{ 
	    const Vertex & v = Th(i);
	    const Label & r(v);
	    double x = v.x;
	    double y = v.y;
	    if ( !! r ) // just for boundary  vertex
		{          
		    D3(0,i) = tgv;
		    D3(1,i) = tgv;
		    U(0,i)  = ((r.lab==1) ? 1 :0) *tgv;
		    U(1,i)  =0;
		}
	}

     
    D3(2,0) = tgv;}     
  
    A.crout();
    U /= A;
  
  
    cout << " ---------- " << endl;  
    cout << "u min " << U(0,'.').min() << "  max =" << U(0,'.').max() << endl;
    cout << "v min " << U(1,'.').min() << "  max =" << U(1,'.').max() << endl;
    cout << "p min " << U(2,'.').min() << "  max =" << U(2,'.').max() << endl;
    cout << " ---------- " << endl;
  
    Th.InitDraw();
    reffecran();
    RN VisoU(20);
    SetDefaultIsoValue( U(2,'.'),Viso);
    SetDefaultIsoValue(U(0,'.'), U(1,'.'),VisoU);
    
    Vh.Draw(U,Viso,2);// Draw p
    Vh.Draw(U,VisoU,0.2,0,1);// Draw u,v
   // Vh.Draw( U(0,'.'), U(1,'.'),0.2);// Draw Vecteur
    extern void ShowAlloc(char *s);
    ShowAlloc("wxcwxcwx");
    rattente(1);

    //  Navier - Stokes 

  
    R dt = 0.05;
    KStokes = 0.001;
    KUV     = 1/dt;
    KVgradP = 1;
    KPena   = 0.001/dt;
/*
    Stokes = (DiffG(0,0)*DiffD(0,0)+DiffG(1,0)*DiffD(1,0))*KUV
                  + Laplace2 *KStokes
                  + (  DiffG(2,1)*DiffD(0,0)+DiffG(2,2)*DiffD(1,0)
                     + DiffG(0,0)*DiffD(2,1)+DiffG(1,0)*DiffD(2,2) ) * KVgradP                 
                  - (DiffG(2,1)*DiffD(2,1)+DiffG(2,2)*DiffD(2,2))*KPena;  
    cout << "NS: " << Stokes << endl;
*/                  
    A = 0;
    for ( i=0;i< Th.nt; i++) 
	A += mate(i,-1,0,0);
    
    { 
	RNM_ D3(A.D,3,Th.nv); // le vecteur diagonal 
	for (i=0;i< Th.nv; i++)
	    { 
		const Vertex & v = Th(i);
		const Label & r(v);
		double x = v.x;
		double y = v.y;
		if ( !! r ) // just for boundary  vertex
		    {          
			D3(0,i) = tgv;
			D3(1,i) = tgv;
		    }
	    }

     
	D3(2,0) = tgv;
    }
    A.crout();
    R temps=0;
    RNM U1(U);
  
    RN_ U1u(U1(0,'.'));
    RN_ U1v(U1(1,'.'));
    RN_ U1p(U1(2,'.'));
  
    RN_ Uu(U(0,'.'));
    RN_ Uv(U(1,'.'));
    RN_ Up(U(2,'.'));
   
    for (int itemps=0;itemps< 500;itemps++)
	{  
	    temps += dt;
	    cout << "----- Iteration " << itemps << " temps = " << temps << endl;
	    U1=0;

	    for ( i=0;i< Th.nt; i++)
		{
		    const QuadratureFormular &FI(QuadratureFormular_T_2);// set the  current Intergration formular
		    assert(FI.on == 3); // verification 
		    const Triangle & K(Th[i]);
		    const FElement  S(Vh[i]);
		    int i0 = S[0]; // the 3 nodes number
		    int i1 = S[1];
		    int i2 = S[2];
		    for (int j=0;j<FI.n;j++) // loop on integration's points
			{
			    QuadraturePoint PI = FI[j];
			    R cc = (R) PI * K.area/dt;
			    R w1(PI.x), w2(PI.y), w0(1-w1-w2); // the value of the 3 basics function 
			    R l[3];
			    l[0]=w0;
			    l[1]=w1;
			    l[2]=w2;
			    int iX=i;
			    Walk(Th,iX,l,Uu,Uv,-dt);
			    const Triangle & KX(Th[iX]);
			    const FElement  SX(Vh[iX]);
			    int ix0 = SX[0]; // the 3 node number of triangle iX;
			    int ix1 = SX[1];
			    int ix2 = SX[2];
 	           
			    R UoX = Uu[ix0]*l[0] + Uu[ix1]*l[1] + Uu[ix2]*l[2];
			    R VoX = Uv[ix0]*l[0] + Uv[ix1]*l[1] + Uv[ix2]*l[2];
	    
			    U1u[i0] += UoX*w0*cc;
			    U1u[i1] += UoX*w1*cc;
			    U1u[i2] += UoX*w2*cc;
	    
			    U1v[i0] += VoX*w0*cc;
			    U1v[i1] += VoX*w1*cc;
			    U1v[i2] += VoX*w2*cc;
			}
		}
	    //  take account Boundary condition 
	    //  rattente(1);

	    for (i=0;i< Th.nv; i++)
		{ 
		    const Vertex & v = Th(i);
		    const Label & r(v);
		    double x = v.x;
		    double y = v.y;
		    if ( !! r ) // just for boundary  vertex
			{          
			    U1u[i]  = ((r.lab==1) ? 1 :0) *tgv;
			    U1v[i]  =0;
			}
		}

	    U1 /= A;
	    U = U1;
	    cout << " u  " <<  U(0,'.').min() << "  " <<  U(0,'.').max() ;
	    cout << " v  " <<  U(1,'.').min() << "  " <<  U(1,'.').max() ;
	    cout << " p  " <<  U(2,'.').min() << "  " <<  U(2,'.').max() << endl;
          if(itemps % 5 == 0) {
	    reffecran();
	    SetDefaultIsoValue(U(2,'.'),Viso);
	    vh.Draw(Up,Viso); // Draw p
        Vh.Draw(U,VisoU,0.2,0,1);// Draw u,v
	    }
	    if(itemps%100==99)  rattente(1);

	} 
 	  ShowAlloc(" On a fini ");
     cout << " On a fini " << endl;
	    reffecran();
	    SetDefaultIsoValue(  U(2,'.'),Viso);
	   vh.Draw(Up,Viso);
       Vh.Draw(U,VisoU,0.2,0,1);// Draw u,v
	   
//	   vh.Draw(Up,Viso);
       rattente(1);  
    closegraphique();
  
    return 0;
}

