
int verbosity =2;
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <iostream>
#include <fstream>
#include "rgraph.hpp"
using namespace std;  

#include "throwassert.hpp"
#include "Expression.hpp"
#include "MatriceCreuse_tpl.hpp"
#include "QuadratureFormular.hpp"
using namespace Fem2D;


void MatStokes(MatriceElementaireSymetrique<R> & mat,const FElement & K, double * p,int,
              int, void* mydata)
 { // 
 
 //   matrix  3x3
 //    e 0 gx
 //    0 e gy 
 //    gx gy d 
    const R eps1 = 0.001;
    const Triangle & T =K.T;  // the current triangle
     
     for (int i=0,i3=0;i<3;i++, i3+=3)
       {
        R2 Gi = T.H(i);// some optimisation        
        for (int j=0,j3=0;j<=i;j++, j3+=3) // the 3 sub matrix
          {
	        R2 Gj = T.H(j);// some optimisation 
	        R gg = (Gi,Gj)* T.area;
	       
//          diagonal 	        
            mat(i3  ,j3   ) =  gg;
            mat(i3+1,j3+1)  =  gg;
            mat(i3+2,j3+2)  = -gg*eps1;
            if(j<i) 
             {
//             Upper part 3x3
               mat(i3  ,j3+1)  = 0 ;
               mat(i3  ,j3+2)  = T.area*Gj.x/3;
               mat(i3+1,j3+2)  = T.area*Gj.y/3;
              }
//            Lower part 3x3            
              mat(i3+1,j3  )  = 0;
              mat(i3+2,j3  )  = T.area*Gi.x/3;            
              mat(i3+2,j3+1)  = T.area*Gi.y/3;             
          }          
 
        }    
       
 }
void ForDebug()
{
  cout << " ForDebug  " << endl;
}
 
int main(int argc,char **argv)
{
  cout << " begin" << endl ;
  int i;
  atexit(ForDebug);
  initgraphique();
  const char  * fn= (argc<2)?"c10x10.msh":argv[1]; 
  Mesh Th(fn);
  Th.renum();
  Th.Draw();
  RN Viso(20),Varrow(20);
  
  FESpace Vh(Th,3); // u,v,p
  MatriceProfile<R> A(Vh);
  MatriceElementaireSymetrique<R> mate(Vh);
  mate.element = MatStokes; 
  for ( i=0;i< Th.nt; i++) A += mate(i,-1,0,0);
   const R tgv = 1e30;
  RNM U(3,Th.nv);
  U = 0;
  RNM_ D3(A.D,3,Th.nv); // le vecteur diagonal de la matrice
  for (i=0;i< Th.nv; i++)
    { 
      const Vertex & v = Th(i);
      const Label & r(v);
      double x = v.x;
      double y = v.y;
     if ( !! r ) // just for boundary  vertex
      {          
        D3(0,i) = tgv;
        D3(1,i) = tgv;
        U(0,i)  = ((r.lab==1) ? 1 :0) *tgv;
        U(1,i)  =0;
      }
     }

     
  D3(2,0) = tgv;     
  A.crout();
  U /= A;
  
    cout << " ---------- " << endl;  
    cout << "u min " << U(0,'.').min() << "  max =" << U(0,'.').max() << endl;
    cout << "v min " << U(1,'.').min() << "  max =" << U(1,'.').max() << endl;
    cout << "p min " << U(2,'.').min() << "  max =" << U(2,'.').max() << endl;
    cout << " ---------- " << endl;
  
  Th.InitDraw();
  reffecran();
  SetDefaultIsoValue( U(2,'.'),Viso);
  SetDefaultIsoValue(U(0,'.'), U(1,'.'),Varrow);

  Vh.Draw(U,Viso,2);// Draw p
  Vh.Draw(U,Varrow,0.2,0,1);// Draw u,v
  
  rattente(1);

  closegraphique();
  
  return 0;
}

